//
//  ES1Renderer.h
//  hw2_graphics
//
//  Created by slork on 1/12/10.
//  Copyright Stanford University 2010. All rights reserved.
//

#import "ESRenderer.h"

#import <OpenGLES/ES1/gl.h>
#import <OpenGLES/ES1/glext.h>

#import "Stk.h"
#import "SineWave.h"
#import "ADSR.h"
#import "NRev.h"
#import "FileWvIn.h"
#import "FMVoices.h"
#import "JCRev.h"

using namespace stk;

struct AudioData {
  SineWave * sineWave;
  //JCRev * reverb;
  ADSR * adsr;
  NRev * reverb;
  FMVoices * fm;
  
  StkFloat curr_note;
  StkFloat note;
};

bool pointWithinCircle(CGPoint p, CGPoint center, CGFloat size);
void updateNote(AudioData * data);

@interface ES1Renderer : NSObject <ESRenderer>
{
  AudioData audioData;
  
@private
	EAGLContext *context;
	
	// The pixel dimensions of the CAEAGLLayer
	GLint backingWidth;
	GLint backingHeight;
	
	// The OpenGL names for the framebuffer and renderbuffer used to render to this view
	GLuint defaultFramebuffer, colorRenderbuffer;
}

- (void) render;
- (BOOL) resizeFromLayer:(CAEAGLLayer *)layer;

@end
