//
//  FlipsideViewController.m
//  hw2
//
//  Created by slork on 1/18/10.
//  Copyright Stanford University 2010. All rights reserved.
//

#import "FlipsideViewController.h"
#import "mopho.h"

#define NUMCOLORS 5

// Extern settings
extern Vector3D g_color;
extern bool g_modulation;
extern bool g_reverb;
extern bool g_glissando;
extern double g_glissando_coef;

@implementation FlipsideViewController

@synthesize delegate;
@synthesize slider;


- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor viewFlipsideBackgroundColor];      
}


- (IBAction)done {
	[self.delegate flipsideViewControllerDidFinish:self];	
}

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
  [slider release];
  [super dealloc];
}

// Reverb Button Pressed
- (IBAction)ReverbButtonPressed:(id)sender {
  UISwitch *button = (UISwitch*)sender;
  
  g_reverb = [button isOn];
}

// Modulation Button is Pressed
- (IBAction)ModulationButtonPressed:(id)sender {
  
  UISwitch *button = (UISwitch*)sender;
  
  g_modulation = [button isOn];
}

// Glissando Button is Pressed
- (IBAction)GlissandoButtonPressed:(id)sender {
  
  UISwitch *button = (UISwitch*)sender;
  
  // Glissando On/Off
  g_glissando = [button isOn];
  
  // Update the glissando coef
  g_glissando_coef = [slider value] - ([slider value] - 0.5)*2;
  
  // Hide/Unhide slider
  [slider setHidden: !g_glissando];
  
}

// Slider Value Changed
- (IBAction)sliderMoved:(id)sender {
  g_glissando_coef = [slider value] - ([slider value] - 0.5)*2;
}




#pragma mark UIPickerViewDelegate

- (void)pickerView:(UIPickerView *)pickerView 
      didSelectRow:(NSInteger)row inComponent:(NSInteger)component {
  
  switch (row) {
    case 0:
      g_color.set(0.0, 0.65, 0.9);  // Cyan
      break;
    case 1:
      g_color.set(0.0, 0.9, 0.65);  // Green
      break;
    case 2:
      g_color.set(0.9, 0.35, 0.0);  // Red
      break;
    case 3:
      g_color.set(0.0, 0.35, 0.9);  // Blue
      break;
    case 4:
      g_color.set(0.8, 0.35, 0.75);  // Pink
      break;
    default:
      g_color.set(1.0, 1.0, 1.0); // Not Set (White)
  }
  
}

- (NSString *)pickerView:(UIPickerView *)pickerView 
             titleForRow:(NSInteger)row forComponent:(NSInteger)component {
  
  switch (row) {
    case 0:
      return @"Cyan";
    case 1:
      return @"Green";
    case 2:
      return @"Red";
    case 3:
      return @"Blue";
    case 4:
      return @"Pink";
    default:
      return @"Not Set";
  }
}

#pragma mark UIPickerViewDataSource

// One Single Component to pick up the Color
- (NSInteger)numberOfComponentsInPickerView:(UIPickerView *)pickerView {
  return 1;
}

// NUMCOLORS of Rows
- (NSInteger)pickerView:(UIPickerView *)pickerView numberOfRowsInComponent:(NSInteger)component {
  return NUMCOLORS;
}


@end
